"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const execa_1 = __importDefault(require("execa"));
exports.compile = async (options) => {
    const args = Object.entries(options)
        .map(([key, value]) => [key.replace(/^/, '--'), value])
        .reduce((result, [key, value]) => [...result, key, value], []);
    let tscOutput = [];
    try {
        await execa_1.default('tsc', args, { all: true });
    }
    catch (error) {
        const { all } = error;
        tscOutput = all.split('\n');
    }
    return tscOutput;
};
